Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_SSL_SOCK_Connector Class Reference

Defines a factory that creates new <ACE_SSL_SOCK_Stream>s actively. More...

`#include <SSL_SOCK_Connector.h>`

Collaboration diagram for ACE_SSL_SOCK_Connector:

[legend]
List of all members.

## Public Types
typedef ACE_INET_Addr | PEER_ADDR
typedef ACE_SSL_SOCK_Stream | PEER_STREAM
## Public Methods
| ACE_SSL_SOCK_Connector (void)
| Default constructor. More...
| ACE_SSL_SOCK_Connector (ACE_SSL_SOCK_Stream &new_stream, const ACE_Addr &remote_sap, const ACE_Time_Value *timeout=0, const ACE_Addr &local_sap=ACE_Addr::sap_any, int reuse_addr=0, int flags=0, int perms=0)
| Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. More...
| ACE_SSL_SOCK_Connector (ACE_SSL_SOCK_Stream &new_stream, const ACE_Addr &remote_sap, ACE_QoS_Params qos_params, const ACE_Time_Value *timeout=0, const ACE_Addr &local_sap=ACE_Addr::sap_any, ACE_Protocol_Info *protocolinfo=0, ACE_SOCK_GROUP g=0, u_long flags=0, int reuse_addr=0, int perms=0)
| Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. More...
| ~ACE_SSL_SOCK_Connector (void)
| Default dtor. More...
int | connect (ACE_SSL_SOCK_Stream &new_stream, const ACE_Addr &remote_sap, const ACE_Time_Value *timeout=0, const ACE_Addr &local_sap=ACE_Addr::sap_any, int reuse_addr=0, int flags=0, int perms=0)
| Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. More...
int | connect (ACE_SSL_SOCK_Stream &new_stream, const ACE_Addr &remote_sap, ACE_QoS_Params qos_params, const ACE_Time_Value *timeout=0, const ACE_Addr &local_sap=ACE_Addr::sap_any, ACE_Protocol_Info *protocolinfo=0, ACE_SOCK_GROUP g=0, u_long flags=0, int reuse_addr=0, int perms=0)
| Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. More...
int | complete (ACE_SSL_SOCK_Stream &new_stream, ACE_Addr *remote_sap=0, const ACE_Time_Value *timeout=0)
| Try to complete a non-blocking connection. More...
int | reset_new_handle (ACE_HANDLE handle)
| Resets any event associations on this handle. More...
void | dump (void) const
| Dump the state of an object. More...
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...
## Protected Methods
int | ssl_connect (ACE_SSL_SOCK_Stream &new_stream, const ACE_Time_Value *timeout)
| Complete non-blocking SSL active connection. More...
## Private Attributes
ACE_SOCK_Connector | connector_
| The class that does all of the non-secure socket connection. It is default contructed, and subsequently used by connect(). More...

## Detailed Description

Defines a factory that creates new <ACE_SSL_SOCK_Stream>s actively.

The ACE_SSL_SOCK_Connector doesn't have a socket of its own, i.e., it simply "borrows" the one from the ACE_SSL_SOCK_Stream that's being connected. The reason for this is that the underlying socket API doesn't use a "factory" socket to connect "data-mode" sockets. Therefore, there's no need to inherit ACE_SSL_SOCK_Connector from ACE_SSL_SOCK.

Since SSL is record-oriented, some additional work is done after the plain socket is connected.

Note:
  The user must currently ensure that only one thread services a given SSL session at any given time since some underlying SSL implementations, such as OpenSSL, are not entirely thread-safe or reentrant.

## Member Typedef Documentation

typedef ACE_INET_Addr ACE_SSL_SOCK_Connector::PEER_ADDR

typedef ACE_SSL_SOCK_Stream ACE_SSL_SOCK_Connector::PEER_STREAM

## Constructor & Destructor Documentation

ASYS_INLINE ACE_SSL_SOCK_Connector::ACE_SSL_SOCK_Connector | ( | void |  | ) |

| Default constructor.

ACE_SSL_SOCK_Connector::ACE_SSL_SOCK_Connector | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | const ACE_Addr & | remote_sap,
|  | const ACE_Time_Value * | timeout = 0,
|  | const ACE_Addr & | local_sap = ACE_Addr::sap_any,
|  | int | reuse_addr = 0,
|  | int | flags = 0,
|  | int | perms = 0
| ) |

  | Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. This method performs both the initial socket connect and the SSL handshake. Parameters:
  new_stream | The `ACE_SSL_SOCK_Stream` object that will be connected to the peer.
  remote_sap | The address that we are trying to connect to. The protocol family of `remote_sap` is used for the connected socket. That is, if `remote_sap` contains an IPv6 address, a socket with family PF_INET6 will be used, else it will be PF_INET.
  timeout | Pointer to an `ACE_Time_Value` object with amount of time to wait to connect. If the pointer is 0 then the call blocks until the connection attempt is complete, whether it succeeds or fails. If *timeout == {0, 0} then the connection is done using nonblocking mode. In this case, if the connection can't be made immediately, this method returns -1 and errno == EWOULDBLOCK. If *timeout > {0, 0} then this is the maximum amount of time to wait before timing out; if the specified amount of time passes before the connection is made, this method returns -1 and errno == ETIME. Note the difference between this case and when a blocking connect is attmpted that TCP times out - in the latter case, errno will be ETIMEDOUT.
  local_sap | (optional) The local address to bind to. If it's the default value of `ACE_Addr::sap_any` then the OS will choose an unused port.
  reuse_addr | (optional) If the value is 1, the local address (`local_sap)` is reused, even if it hasn't been cleaned up yet.
  flags | Ignored.
  perms | Ignored.
Returns: Returns 0 if the connection succeeds. If it fails, -1 is returned and errno contains a specific error code.

ACE_SSL_SOCK_Connector::ACE_SSL_SOCK_Connector | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | const ACE_Addr & | remote_sap,
|  | ACE_QoS_Params | qos_params,
|  | const ACE_Time_Value * | timeout = 0,
|  | const ACE_Addr & | local_sap = ACE_Addr::sap_any,
|  | ACE_Protocol_Info * | protocolinfo = 0,
|  | ACE_SOCK_GROUP | g = 0,
|  | u_long | flags = 0,
|  | int | reuse_addr = 0,
|  | int | perms = 0
| ) |

  | Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. This method performs both the initial socket connect and the SSL handshake. Parameters:
  new_stream | The `ACE_SSL_SOCK_Stream` object that will be connected to the peer.
  remote_sap | The address that we are trying to connect to. The protocol family of `remote_sap` is used for the connected socket. That is, if `remote_sap` contains an IPv6 address, a socket with family PF_INET6 will be used, else it will be PF_INET.
  qos_params | Contains QoS parameters that are passed to the IntServ (RSVP) and DiffServ protocols.
  See also: ACE_QoS_Params. Parameters:
  timeout | Pointer to an `ACE_Time_Value` object with amount of time to wait to connect. If the pointer is 0 then the call blocks until the connection attempt is complete, whether it succeeds or fails. If *timeout == {0, 0} then the connection is done using nonblocking mode. In this case, if the connection can't be made immediately, this method returns -1 and errno == EWOULDBLOCK. If *timeout > {0, 0} then this is the maximum amount of time to wait before timing out; if the specified amount of time passes before the connection is made, this method returns -1 and errno == ETIME. Note the difference between this case and when a blocking connect is attmpted that TCP times out - in the latter case, errno will be ETIMEDOUT.
  local_sap | (optional) The local address to bind to. If it's the default value of `ACE_Addr::sap_any` then the OS will choose an unused port.
  reuse_addr | (optional) If the value is 1, the local address (`local_sap)` is reused, even if it hasn't been cleaned up yet.
  flags | Ignored.
  perms | Ignored.
Returns: Returns 0 if the connection succeeds. If it fails, -1 is returned and errno contains a specific error code.

ACE_SSL_SOCK_Connector::~ACE_SSL_SOCK_Connector | ( | void |  | ) |

| Default dtor.

## Member Function Documentation

int ACE_SSL_SOCK_Connector::complete | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | ACE_Addr * | remote_sap = 0,
|  | const ACE_Time_Value * | tv = 0
| ) |

| Try to complete a non-blocking connection. If connection completion is successful then <new_stream> contains the connected ACE_SSL_SOCK_Stream. If <remote_sap> is non-NULL then it will contain the address of the connected peer.

int ACE_SSL_SOCK_Connector::connect | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | const ACE_Addr & | remote_sap,
|  | ACE_QoS_Params | qos_params,
|  | const ACE_Time_Value * | timeout = 0,
|  | const ACE_Addr & | local_sap = ACE_Addr::sap_any,
|  | ACE_Protocol_Info * | protocolinfo = 0,
|  | ACE_SOCK_GROUP | g = 0,
|  | u_long | flags = 0,
|  | int | reuse_addr = 0,
|  | int | perms = 0
| ) |

  | Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. This method performs both the initial socket connect and the SSL handshake. Parameters:
  new_stream | The `ACE_SSL_SOCK_Stream` object that will be connected to the peer.
  remote_sap | The address that we are trying to connect to. The protocol family of `remote_sap` is used for the connected socket. That is, if `remote_sap` contains an IPv6 address, a socket with family PF_INET6 will be used, else it will be PF_INET.
  qos_params | Contains QoS parameters that are passed to the IntServ (RSVP) and DiffServ protocols.
  See also: ACE_QoS_Params. Parameters:
  timeout | Pointer to an `ACE_Time_Value` object with amount of time to wait to connect. If the pointer is 0 then the call blocks until the connection attempt is complete, whether it succeeds or fails. If *timeout == {0, 0} then the connection is done using nonblocking mode. In this case, if the connection can't be made immediately, this method returns -1 and errno == EWOULDBLOCK. If *timeout > {0, 0} then this is the maximum amount of time to wait before timing out; if the specified amount of time passes before the connection is made, this method returns -1 and errno == ETIME. Note the difference between this case and when a blocking connect is attmpted that TCP times out - in the latter case, errno will be ETIMEDOUT.
  local_sap | (optional) The local address to bind to. If it's the default value of `ACE_Addr::sap_any` then the OS will choose an unused port.
  reuse_addr | (optional) If the value is 1, the local address (`local_sap)` is reused, even if it hasn't been cleaned up yet.
  flags | Ignored.
  perms | Ignored.
Returns: Returns 0 if the connection succeeds. If it fails, -1 is returned and errno contains a specific error code.

int ACE_SSL_SOCK_Connector::connect | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | const ACE_Addr & | remote_sap,
|  | const ACE_Time_Value * | timeout = 0,
|  | const ACE_Addr & | local_sap = ACE_Addr::sap_any,
|  | int | reuse_addr = 0,
|  | int | flags = 0,
|  | int | perms = 0
| ) |

  | Actively connect to a peer, producing a connected `ACE_SSL_SOCK_Stream` object if the connection succeeds. This method performs both the initial socket connect and the SSL handshake. Parameters:
  new_stream | The `ACE_SSL_SOCK_Stream` object that will be connected to the peer.
  remote_sap | The address that we are trying to connect to. The protocol family of `remote_sap` is used for the connected socket. That is, if `remote_sap` contains an IPv6 address, a socket with family PF_INET6 will be used, else it will be PF_INET.
  timeout | Pointer to an `ACE_Time_Value` object with amount of time to wait to connect. If the pointer is 0 then the call blocks until the connection attempt is complete, whether it succeeds or fails. If *timeout == {0, 0} then the connection is done using nonblocking mode. In this case, if the connection can't be made immediately, this method returns -1 and errno == EWOULDBLOCK. If *timeout > {0, 0} then this is the maximum amount of time to wait before timing out; if the specified amount of time passes before the connection is made, this method returns -1 and errno == ETIME. Note the difference between this case and when a blocking connect is attmpted that TCP times out - in the latter case, errno will be ETIMEDOUT.
  local_sap | (optional) The local address to bind to. If it's the default value of `ACE_Addr::sap_any` then the OS will choose an unused port.
  reuse_addr | (optional) If the value is 1, the local address (`local_sap)` is reused, even if it hasn't been cleaned up yet.
  flags | Ignored.
  perms | Ignored.
Returns: Returns 0 if the connection succeeds. If it fails, -1 is returned and errno contains a specific error code.

ASYS_INLINE void ACE_SSL_SOCK_Connector::dump | ( | void |  | ) | const

| Dump the state of an object.

ASYS_INLINE int ACE_SSL_SOCK_Connector::reset_new_handle | ( | ACE_HANDLE | handle | ) |

| Resets any event associations on this handle.

int ACE_SSL_SOCK_Connector::ssl_connect | ( | ACE_SSL_SOCK_Stream & | new_stream,
|  | const ACE_Time_Value * | timeout
| ) | `[protected]`

| Complete non-blocking SSL active connection.

## Member Data Documentation

ACE_SSL_SOCK_Connector::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

ACE_SOCK_Connector ACE_SSL_SOCK_Connector::connector_`[private]`

| The class that does all of the non-secure socket connection. It is default contructed, and subsequently used by connect().

The documentation for this class was generated from the following files:

- SSL_SOCK_Connector.h
- SSL_SOCK_Connector.cpp
- SSL_SOCK_Connector.i